<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="报警点位" prop="pointName">
        <el-input
          v-model="queryParams.pointName"
          placeholder="请输入报警点位"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="报警时间" prop="time">
        <el-date-picker
          clearable
          v-model="queryParams.time"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="请选择报警时间"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>
    <!-- 
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:abnormal:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row> -->

    <el-table
      v-loading="loading"
      :data="abnormalList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column label="报警点位" align="center" prop="pointName" />
      <el-table-column label="报警监测项" align="center" prop="items" />
      <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <span v-if="scope.row.status == 0" style="color: #67c23a"
            >已解除</span
          >
          <span v-if="scope.row.status == 1" style="color: #f56c6c">报警</span>
        </template>
      </el-table-column>
      <el-table-column label="报警值" align="center" prop="evalue" />
      <el-table-column label="报警级别" align="center" prop="alarmlevel">
        <template slot-scope="scope">
          <span v-if="scope.row.alarmlevel == 1" style="color: #fa0606"
            >一级报警</span
          >
          <span v-if="scope.row.alarmlevel == 2" style="color: #fc5004"
            >二级报警</span
          >
          <span v-if="scope.row.alarmlevel == 3" style="color: #98992b"
            >三级报警</span
          >
          <span v-if="scope.row.alarmlevel == 4" style="color: #0533fc"
            >四级报警</span
          >
        </template>
      </el-table-column>
      <el-table-column label="报警时间" align="center" prop="time" width="180">
        <template slot-scope="scope">
          <span>{{
            parseTime(scope.row.time, "{y}-{m}-{d} {h}:{m}:{s}")
          }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="解除报警时间"
        align="center"
        prop="jcbjtime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{
            parseTime(scope.row.jcbjtime, "{y}-{m}-{d} {h}:{m}:{s}")
          }}</span>
        </template>
      </el-table-column>
      <el-table-column label="数据报警原因" align="center" prop="reason" />
      <el-table-column label="解除报警原因" align="center" prop="jcreason" />
      <el-table-column label="解除人" align="center" prop="jcman" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            v-if="scope.row.status == 1"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:abnormal:edit']"
            >解除报警</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改环境监测报警记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-row>
          <el-col :span="24">
            <el-form-item label="解除报警原因" prop="jcreason">
              <el-input
                v-model="form.jcreason"
                type="textarea"
                placeholder="请输入内容"
              />
            </el-form-item>
          </el-col>
          <el-col :span="15">
            <el-form-item label="该时间内不报警" prop="jchours">
              <el-input-number
                v-model="openAlarm"
                @change="cancelAlarmNum"
                :min="0"
                :step="0.5"
                label="请输入时间"
              ></el-input-number>
              <span>小时</span>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <span>{{ newdate }}之前不再报警</span>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listAbnormal,
  getAbnormal,
  delAbnormal,
  addAbnormal,
  updateAbnormal,
} from "@/api/envi/envialarm";

export default {
  name: "Abnormal",
  data() {
    return {
      newdate: 0,
      //解除报警时间
      openAlarm: 0,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 环境监测报警记录表格数据
      abnormalList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        pointName: null,
        items: null,
        evalue: null,
        alarmlevel: null,
        time: null,
        jcbjtime: null,
        reason: null,
        jcreason: null,
        jchours: null,
        jcman: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getList();
    let nowUser = this.$store.getters.name;
    console.log(this.$store.getters.name);
  },
  methods: {
    getYMDHMS(timestamp) {
      let time = new Date(timestamp);
      let year = time.getFullYear();
      let month = time.getMonth() + 1;
      let date = time.getDate();
      let hours = time.getHours();
      let minute = time.getMinutes();
      let second = time.getSeconds();

      if (month < 10) {
        month = "0" + month;
      }
      if (date < 10) {
        date = "0" + date;
      }
      if (hours < 10) {
        hours = "0" + hours;
      }
      if (minute < 10) {
        minute = "0" + minute;
      }
      if (second < 10) {
        second = "0" + second;
      }
      this.newdate =
        year +
        "-" +
        month +
        "-" +
        date +
        " " +
        hours +
        ":" +
        minute +
        ":" +
        second;
    },

    cancelAlarmNum(e) {
      let num = e;
      let date = Date.parse(new Date());
      console.log(date);
      let afterdate = date + num * 1000 * 60 * 60;
      this.getYMDHMS(afterdate);
      // let newcacleTime = dateFormat(cancleTime, "yyyy-MM-dd hh:mm:ss");
      console.log(this.newdate);
    },
    /** 查询环境监测报警记录列表 */
    getList() {
      this.loading = true;
      listAbnormal(this.queryParams).then((response) => {
        this.abnormalList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        pointName: null,
        items: null,
        evalue: null,
        alarmlevel: null,
        time: null,
        jcbjtime: null,
        reason: null,
        jcreason: null,
        jchours: null,
        jcman: null,
        createTime: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加环境监测报警记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getAbnormal(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改环境监测报警记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          let that = this;
          if (this.form.id != null) {
            let data = {
              id: that.form.id,
              jcbjtime: that.newdate,
              status: 0,
              jcreason: that.form.jcreason,
              jcman: this.$store.getters.name,
            };
            updateAbnormal(data).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAbnormal(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm("是否确认删除该环境监测报警记录？")
        .then(function () {
          return delAbnormal(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/abnormal/export",
        {
          ...this.queryParams,
        },
        `abnormal_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
